HDU-1498-50 years,50 colors【二分匹配】【最小顶点覆盖】

来源:互联网 发布:网络电视不能看回放 编辑:程序博客网 时间:2024/06/10 09:05

题目链接:点击打开链接

50 years, 50 colors

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2296    Accepted Submission(s): 1295


Problem Description
On Octorber 21st, HDU 50-year-celebration, 50-color balloons floating around the campus, it's so nice, isn't it? To celebrate this meaningful day, the ACM team of HDU hold some fuuny games. Especially, there will be a game named "crashing color balloons".

There will be a n*n matrix board on the ground, and each grid will have a color balloon in it.And the color of the ballon will be in the range of [1, 50].After the referee shouts "go!",you can begin to crash the balloons.Every time you can only choose one kind of balloon to crash, we define that the two balloons with the same color belong to the same kind.What's more, each time you can only choose a single row or column of balloon, and crash the balloons that with the color you had chosen. Of course, a lot of students are waiting to play this game, so we just give every student k times to crash the balloons.

Here comes the problem: which kind of balloon is impossible to be all crashed by a student in k times.


 

Input
There will be multiple input cases.Each test case begins with two integers n, k. n is the number of rows and columns of the balloons (1 <= n <= 100), and k is the times that ginving to each student(0 < k <= n).Follow a matrix A of n*n, where Aij denote the color of the ballon in the i row, j column.Input ends with n = k = 0.
 

Output
For each test case, print in ascending order all the colors of which are impossible to be crashed by a student in k times. If there is no choice, print "-1".
 

Sample Input
1 112 11 11 22 11 22 25 41 2 3 4 52 3 4 5 13 4 5 1 24 5 1 2 35 1 2 3 43 350 50 5050 50 5050 50 500 0
 

Sample Output
-1121 2 3 4 5-1



题意:一个 n *  n矩阵,每个格子放一个气球,气球有颜色。一个人一次可以选择一种颜色的气球,再选择一行或者一列,把该种颜色的气球踩破

题解:我们先考虑矩阵内一种颜色的情况,如果要我们用最小的次数打掉所以的红色的气球,因为我们每次能打掉同一行或同一列的, 由于每次撞气球都是用行或者列的办法,那么问题就转化成了用最少的行或列来撞破红色的气球,于是想到了二分图的最小顶点覆盖………

将行作为左边的点,列作为右边的点,原图中的每个点相当于二分图中的每一行边,而用最小的行或者列去打掉气球,就相当于用二分图中最小的顶点去覆盖掉所有的边在二分图中求最少的点,让每条边都至少和其中的一个点关联,这就是二分图的“最小顶点覆盖”。

二分图的最小顶点覆盖数 =二分图的最大匹配数。

#include<cstdio>#include<algorithm>#include<cstring>using namespace std;int n,k;int map[110][110];bool vis[110];bool mark[110];int match[110];bool find(int t,int x){for(int i=0;i<n;i++){if(!mark[i]&&map[x][i]==t){mark[i]=1;if(match[i]==-1||find(t,match[i])){match[i]=x;return 1;}}}return 0;}int solve(int t){int ans=0;memset(match,-1,sizeof(match));for(int i=0;i<n;i++){memset(mark,0,sizeof(mark));if(find(t,i))ans++;}return ans;}int main(){while(scanf("%d %d",&n,&k)&&(n||k)){memset(map,0,sizeof(map));memset(vis,0,sizeof(vis));for(int i=0;i<n;i++){for(int j=0;j<n;j++){int a;scanf("%d",&a);map[i][j]=a;vis[a]=1; // 标记出现的气球类型 }}int cnt,num=0,ans[110];for(int i=1;i<=50;i++) // 遍历 50种类型的气球 {if(vis[i]) // 被标记的气球类型 {cnt=solve(i); // 匹配数大于 k,则不能把 i这种类型的气球完全踩完 if(cnt>k)ans[num++]=i;}}if(num==0)puts("-1");else{for(int i=0;i<num;i++)printf(i==0?"%d":" %d",ans[i]);puts("");}}return 0;}

0 0
原创粉丝点击